/*!
FullCalendar Scheduler v5.3.1
Docs & License: https://fullcalendar.io/scheduler
(c) 2020 Adam Shaw
*/
var FullCalendarTimeline=function(e,t,n,i){"use strict";n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n;var o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)};function r(e,t){function n(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}var a=function(){return(a=Object.assign||function(e){for(var t,n=1,i=arguments.length;n<i;n++)for(var o in t=arguments[n])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};t.config.MAX_TIMELINE_SLOTS=1e3;var s=[{years:1},{months:1},{days:1},{hours:1},{minutes:30},{minutes:15},{minutes:10},{minutes:5},{minutes:1},{seconds:30},{seconds:15},{seconds:10},{seconds:5},{seconds:1},{milliseconds:500},{milliseconds:100},{milliseconds:10},{milliseconds:1}];function l(e,n,i,o){var r={labelInterval:i.slotLabelInterval,slotDuration:i.slotDuration};!function(e,n,i){var o=n.currentRange;if(e.labelInterval){i.countDurationsBetween(o.start,o.end,e.labelInterval)>t.config.MAX_TIMELINE_SLOTS&&(console.warn("slotLabelInterval results in too many cells"),e.labelInterval=null)}if(e.slotDuration){i.countDurationsBetween(o.start,o.end,e.slotDuration)>t.config.MAX_TIMELINE_SLOTS&&(console.warn("slotDuration results in too many cells"),e.slotDuration=null)}if(e.labelInterval&&e.slotDuration){var r=t.wholeDivideDurations(e.labelInterval,e.slotDuration);(null===r||r<1)&&(console.warn("slotLabelInterval must be a multiple of slotDuration"),e.slotDuration=null)}}(r,e,n),d(r,e,n),function(e,n,i){var o=n.currentRange,r=e.slotDuration;if(!r){for(var a=d(e,n,i),l=0,u=s;l<u.length;l++){var c=u[l],h=t.createDuration(c),f=t.wholeDivideDurations(a,h);if(null!==f&&f>1&&f<=6){r=h;break}}if(r)i.countDurationsBetween(o.start,o.end,r)>200&&(r=null);r||(r=a),e.slotDuration=r}}(r,e,n);var a=i.slotLabelFormat,l=Array.isArray(a)?a:null!=a?[a]:function(e,n,i,o){var r,a,s=e.labelInterval,l=t.greatestDurationDenominator(s).unit,u=o.weekNumbers,c=r=a=null;"week"!==l||u||(l="day");switch(l){case"year":c={year:"numeric"};break;case"month":h("years",n,i)>1&&(c={year:"numeric"}),r={month:"short"};break;case"week":h("years",n,i)>1&&(c={year:"numeric"}),r={week:"narrow"};break;case"day":h("years",n,i)>1?c={year:"numeric",month:"long"}:h("months",n,i)>1&&(c={month:"long"}),u&&(r={week:"short"}),a={weekday:"narrow",day:"numeric"};break;case"hour":u&&(c={week:"short"}),h("days",n,i)>1&&(r={weekday:"short",day:"numeric",month:"numeric",omitCommas:!0}),a={hour:"numeric",minute:"2-digit",omitZeroMinute:!0,meridiem:"short"};break;case"minute":t.asRoughMinutes(s)/60>=6?(c={hour:"numeric",meridiem:"short"},r=function(e){return":"+t.padStart(e.date.minute,2)}):c={hour:"numeric",minute:"numeric",meridiem:"short"};break;case"second":t.asRoughSeconds(s)/60>=6?(c={hour:"numeric",minute:"2-digit",meridiem:"lowercase"},r=function(e){return":"+t.padStart(e.date.second,2)}):c={hour:"numeric",minute:"2-digit",second:"2-digit",meridiem:"lowercase"};break;case"millisecond":c={hour:"numeric",minute:"2-digit",second:"2-digit",meridiem:"lowercase"},r=function(e){return"."+t.padStart(e.millisecond,3)}}return[].concat(c||[],r||[],a||[])}(r,e,n,i);r.headerFormats=l.map((function(e){return t.createFormatter(e)})),r.isTimeScale=Boolean(r.slotDuration.milliseconds);var m=null;if(!r.isTimeScale){var p=t.greatestDurationDenominator(r.slotDuration).unit;/year|month|week/.test(p)&&(m=p)}r.largeUnit=m,r.emphasizeWeeks=1===t.asCleanDays(r.slotDuration)&&h("weeks",e,n)>=2&&!i.businessHours;var g,v,y=i.snapDuration;y&&(g=t.createDuration(y),v=t.wholeDivideDurations(r.slotDuration,g)),null==v&&(g=r.slotDuration,v=1),r.snapDuration=g,r.snapsPerSlot=v;var D=t.asRoughMs(e.slotMaxTime)-t.asRoughMs(e.slotMinTime),S=u(e.renderRange.start,r,n),C=u(e.renderRange.end,r,n);r.isTimeScale&&(S=n.add(S,e.slotMinTime),C=n.add(t.addDays(C,-1),e.slotMaxTime)),r.timeWindowMs=D,r.normalizedRange={start:S,end:C};for(var R=[],w=S;w<C;)c(w,r,e,o)&&R.push(w),w=n.add(w,r.slotDuration);r.slotDates=R;var E=-1,b=0,P=[],k=[];for(w=S;w<C;)c(w,r,e,o)?(E++,P.push(E),k.push(b)):P.push(E+.5),w=n.add(w,r.snapDuration),b++;return r.snapDiffToIndex=P,r.snapIndexToDiff=k,r.snapCnt=E+1,r.slotCnt=r.snapCnt/r.snapsPerSlot,r.isWeekStarts=function(e,t){for(var n=e.slotDates,i=e.emphasizeWeeks,o=null,r=[],a=0,s=n;a<s.length;a++){var l=s[a],u=t.computeWeekNumber(l),c=i&&null!==o&&o!==u;o=u,r.push(c)}return r}(r,n),r.cellRows=function(e,n){for(var i=e.slotDates,o=e.headerFormats,r=o.map((function(){return[]})),a=t.asCleanDays(e.slotDuration),s=7===a?"week":1===a?"day":null,l=o.map((function(e){return e.getLargestUnit?e.getLargestUnit():null})),u=0;u<i.length;u++)for(var c=i[u],d=e.isWeekStarts[u],h=0;h<o.length;h++){var m=o[h],p=r[h],g=p[p.length-1],v=h===o.length-1,y=o.length>1&&!v,D=null,S=l[h]||(v?s:null);if(y){var C=n.format(c,m);g&&g.text===C?g.colspan+=1:D=f(c,C,S)}else if(!g||t.isInt(n.countDurationsBetween(e.normalizedRange.start,c,e.labelInterval))){C=n.format(c,m);D=f(c,C,S)}else g.colspan+=1;D&&(D.weekStart=d,p.push(D))}return r}(r,n),r.slotsPerLabel=t.wholeDivideDurations(r.labelInterval,r.slotDuration),r}function u(e,n,i){var o=e;return n.isTimeScale||(o=t.startOfDay(o),n.largeUnit&&(o=i.startOf(o,n.largeUnit))),o}function c(e,n,i,o){if(o.isHiddenDay(e))return!1;if(n.isTimeScale){var r=t.startOfDay(e),a=e.valueOf()-r.valueOf()-t.asRoughMs(i.slotMinTime);return(a=(a%864e5+864e5)%864e5)<n.timeWindowMs}return!0}function d(e,n,i){var o=n.currentRange,r=e.labelInterval;if(!r){var a=void 0;if(e.slotDuration){for(var l=0,u=s;l<u.length;l++){a=u[l];var c=t.createDuration(a),d=t.wholeDivideDurations(c,e.slotDuration);if(null!==d&&d<=6){r=c;break}}r||(r=e.slotDuration)}else for(var h=0,f=s;h<f.length;h++){if(a=f[h],r=t.createDuration(a),i.countDurationsBetween(o.start,o.end,r)>=18)break}e.labelInterval=r}return r}function h(e,n,i){var o=n.currentRange,r=null;return"years"===e?r=i.diffWholeYears(o.start,o.end):"months"===e||"weeks"===e?r=i.diffWholeMonths(o.start,o.end):"days"===e&&(r=t.diffWholeDays(o.start,o.end)),r||0}function f(e,t,n){return{date:e,text:t,rowUnit:n,colspan:1,isWeekStart:!1}}var m=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.refineHookProps=t.memoizeObjArg(v),n.normalizeClassNames=t.buildClassNameNormalizer(),n}return r(n,e),n.prototype.render=function(){var e=this.props,n=this.context,i=n.dateEnv,o=n.options,r=e.cell,a=e.dateProfile,s=e.tDateProfile,l=t.getDateMeta(r.date,e.todayRange,e.nowDate,a),u=["fc-timeline-slot","fc-timeline-slot-label"].concat("time"===r.rowUnit?t.getSlotClassNames(l,n.theme):t.getDayClassNames(l,n.theme));r.isWeekStart&&u.push("fc-timeline-slot-em");var c=o.navLinks&&r.rowUnit&&"time"!==r.rowUnit?t.buildNavLinkData(r.date,r.rowUnit):null,d=this.refineHookProps({level:e.rowLevel,dateMarker:r.date,text:r.text,dateEnv:n.dateEnv,viewApi:n.viewApi}),h=this.normalizeClassNames(o.slotLabelClassNames,d);return t.createElement(t.MountHook,{hookProps:d,didMount:o.slotLabelDidMount,willUnmount:o.slotLabelWillUnmount},(function(n){return t.createElement("th",{ref:n,className:u.concat(h).join(" "),"data-date":i.formatIso(r.date,{omitTime:!s.isTimeScale,omitTimeZoneOffset:!0}),colSpan:r.colspan},t.createElement("div",{className:"fc-timeline-slot-frame",style:{height:e.rowInnerHeight}},t.createElement(p,{hookProps:d,isSticky:e.isSticky,navLinkData:c})))}))},n}(t.BaseComponent),p=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return r(n,e),n.prototype.render=function(){var e=this.props,n=this.context,i=e.navLinkData?{"data-navlink":e.navLinkData,tabIndex:0}:{};return t.createElement(t.ContentHook,{hookProps:e.hookProps,content:n.options.slotLabelContent,defaultContent:g},(function(n,o){return t.createElement("a",a({ref:n,className:"fc-timeline-slot-cushion fc-scrollgrid-sync-inner"+(e.isSticky?" fc-sticky":"")},i),o)}))},n}(t.BaseComponent);function g(e){return e.text}function v(e){return{level:e.level,date:e.dateEnv.toDate(e.dateMarker),view:e.viewApi,text:e.text}}var y=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return r(n,e),n.prototype.render=function(){var e=this.props,n=e.dateProfile,i=e.tDateProfile,o=e.rowInnerHeights,r=e.todayRange,a=e.nowDate,s=i.cellRows;return t.createElement(t.Fragment,null,s.map((function(e,l){var u=l===s.length-1,c=["fc-timeline-header-row",i.isTimeScale&&u?"fc-timeline-header-row-chrono":""];return t.createElement("tr",{key:l,className:c.join(" ")},e.map((function(e){return t.createElement(m,{key:e.date.toISOString(),cell:e,rowLevel:l,dateProfile:n,tDateProfile:i,todayRange:r,nowDate:a,rowInnerHeight:o&&o[l],isSticky:!u})})))})))},n}(t.BaseComponent),D=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n}return r(n,e),n.prototype.render=function(){var e=this,n=this.props,i=this.context,o=t.greatestDurationDenominator(n.tDateProfile.slotDuration).unit,r=n.slatCoords&&n.slatCoords.dateProfile===n.dateProfile?n.slatCoords:null;return t.createElement(t.NowTimer,{unit:o},(function(o,a){return t.createElement("div",{className:"fc-timeline-header",ref:e.rootElRef},t.createElement("table",{className:"fc-scrollgrid-sync-table",style:{minWidth:n.tableMinWidth,width:n.clientWidth}},n.tableColGroupNode,t.createElement("tbody",null,t.createElement(y,{dateProfile:n.dateProfile,tDateProfile:n.tDateProfile,nowDate:o,todayRange:a,rowInnerHeights:n.rowInnerHeights}))),i.options.nowIndicator&&t.createElement("div",{className:"fc-timeline-now-indicator-container"},r&&r.isDateInRange(o)&&t.createElement(t.NowIndicatorRoot,{isAxis:!0,date:o},(function(e,n,i,a){return t.createElement("div",{ref:e,className:["fc-timeline-now-indicator-arrow"].concat(n).join(" "),style:{left:r.dateToCoord(o)}},a)}))))}))},n.prototype.componentDidMount=function(){this.updateSize()},n.prototype.componentDidUpdate=function(){this.updateSize()},n.prototype.updateSize=function(){this.props.onMaxCushionWidth&&this.props.onMaxCushionWidth(this.computeMaxCushionWidth())},n.prototype.computeMaxCushionWidth=function(){return Math.max.apply(Math,t.findElements(this.rootElRef.current,".fc-timeline-header-row:last-child .fc-timeline-slot-cushion").map((function(e){return e.getBoundingClientRect().width})))},n}(t.BaseComponent),S=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return r(n,e),n.prototype.render=function(){var e=this.props,n=this.context,i=n.dateEnv,o=n.options,r=n.theme,s=e.date,l=e.tDateProfile,u=e.isEm,c=t.getDateMeta(e.date,e.todayRange,e.nowDate,e.dateProfile),d=["fc-timeline-slot","fc-timeline-slot-lane"],h={"data-date":i.formatIso(s,{omitTimeZoneOffset:!0,omitTime:!l.isTimeScale})},f=a(a({date:i.toDate(e.date)},c),{view:n.viewApi});return u&&d.push("fc-timeline-slot-em"),l.isTimeScale&&d.push(t.isInt(i.countDurationsBetween(l.normalizedRange.start,e.date,l.labelInterval))?"fc-timeline-slot-major":"fc-timeline-slot-minor"),d.push.apply(d,e.isDay?t.getDayClassNames(c,r):t.getSlotClassNames(c,r)),t.createElement(t.RenderHook,{hookProps:f,classNames:o.slotLaneClassNames,content:o.slotLaneContent,didMount:o.slotLaneDidMount,willUnmount:o.slotLaneWillUnmount,elRef:e.elRef},(function(e,n,i,o){return t.createElement("td",a({ref:e,className:d.concat(n).join(" ")},h),t.createElement("div",{ref:i},o))}))},n}(t.BaseComponent),C=function(){function e(e,n,i,o,r,a){this.slatRootEl=e,this.dateProfile=i,this.tDateProfile=o,this.dateEnv=r,this.isRtl=a,this.outerCoordCache=new t.PositionCache(e,n,!0,!1),this.innerCoordCache=new t.PositionCache(e,t.findDirectChildren(n,"div"),!0,!1)}return e.prototype.rangeToCoords=function(e){return this.isRtl?{right:this.dateToCoord(e.start),left:this.dateToCoord(e.end)}:{left:this.dateToCoord(e.start),right:this.dateToCoord(e.end)}},e.prototype.isDateInRange=function(e){return t.rangeContainsMarker(this.dateProfile.currentRange,e)},e.prototype.dateToCoord=function(e){var t=this.tDateProfile,n=this.computeDateSnapCoverage(e)/t.snapsPerSlot,i=Math.floor(n),o=n-(i=Math.min(i,t.slotCnt-1)),r=this.innerCoordCache,a=this.outerCoordCache;return this.isRtl?a.rights[i]-r.getWidth(i)*o-a.originClientRect.width:a.lefts[i]+r.getWidth(i)*o},e.prototype.computeDateSnapCoverage=function(e){return R(e,this.tDateProfile,this.dateEnv)},e.prototype.computeDurationLeft=function(e){var n=this.dateProfile,i=this.tDateProfile,o=this.dateEnv,r=this.isRtl,a=0;if(n){var s=o.add(n.activeRange.start,e);i.isTimeScale||(s=t.startOfDay(s)),a=this.dateToCoord(s),!r&&a&&(a+=1)}return a},e}();function R(e,n,i){var o=i.countDurationsBetween(n.normalizedRange.start,e,n.snapDuration);if(o<0)return 0;if(o>=n.snapDiffToIndex.length)return n.snapCnt;var r=Math.floor(o),a=n.snapDiffToIndex[r];return t.isInt(a)?a+=o-r:a=Math.ceil(a),a}var w=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n.cellElRefs=new t.RefMap,n.handleScrollRequest=function(e){var t=n.props.onScrollLeftRequest,i=n.coords;if(t&&i){if(e.time)t(i.computeDurationLeft(e.time));return!0}},n}return r(n,e),n.prototype.render=function(){var e=this.props,n=this.context;return t.createElement("div",{className:"fc-timeline-slots",ref:this.rootElRef},t.createElement("table",{className:n.theme.getClass("table"),style:{minWidth:e.tableMinWidth,width:e.clientWidth}},e.tableColGroupNode,t.createElement(E,{cellElRefs:this.cellElRefs,dateProfile:e.dateProfile,tDateProfile:e.tDateProfile,nowDate:e.nowDate,todayRange:e.todayRange})))},n.prototype.componentDidMount=function(){this.updateSizing(),this.scrollResponder=this.context.createScrollResponder(this.handleScrollRequest)},n.prototype.componentDidUpdate=function(e){this.updateSizing(),this.scrollResponder.update(e.dateProfile!==this.props.dateProfile)},n.prototype.componentWillUnmount=function(){this.scrollResponder.detach(),this.props.onCoords&&this.props.onCoords(null)},n.prototype.updateSizing=function(){var e,t=this.props,n=this.context;null!==t.clientWidth&&this.scrollResponder&&(this.rootElRef.current.offsetWidth&&(this.coords=new C(this.rootElRef.current,(e=this.cellElRefs.currentMap,t.tDateProfile.slotDates.map((function(t){var n=t.toISOString();return e[n]}))),t.dateProfile,t.tDateProfile,n.dateEnv,n.isRtl),t.onCoords&&t.onCoords(this.coords),this.scrollResponder.update(!1)))},n.prototype.positionToHit=function(e){var n=this.coords.outerCoordCache,i=this.context,o=i.dateEnv,r=i.isRtl,a=this.props.tDateProfile,s=n.leftToIndex(e);if(null!=s){var l=n.getWidth(s),u=r?(n.rights[s]-e)/l:(e-n.lefts[s])/l,c=Math.floor(u*a.snapsPerSlot),d=o.add(a.slotDates[s],t.multiplyDuration(a.snapDuration,c));return{dateSpan:{range:{start:d,end:o.add(d,a.snapDuration)},allDay:!this.props.tDateProfile.isTimeScale},dayEl:this.cellElRefs.currentMap[s],left:n.lefts[s],right:n.rights[s]}}return null},n}(t.BaseComponent),E=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return r(n,e),n.prototype.render=function(){var e=this.props,n=e.tDateProfile,i=e.cellElRefs,o=n.slotDates,r=n.isWeekStarts,a=!n.isTimeScale&&!n.largeUnit;return t.createElement("tbody",null,t.createElement("tr",null,o.map((function(o,s){var l=o.toISOString();return t.createElement(S,{key:l,elRef:i.createRef(l),date:o,dateProfile:e.dateProfile,tDateProfile:n,nowDate:e.nowDate,todayRange:e.todayRange,isEm:r[s],isDay:a})}))))},n}(t.BaseComponent);var b=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return r(n,e),n.prototype.render=function(){var e=this.props,n=[].concat(e.eventResizeSegs,e.dateSelectionSegs);return e.timelineCoords&&t.createElement("div",{className:"fc-timeline-bg"},this.renderSegs(e.businessHourSegs||[],e.timelineCoords,"non-business"),this.renderSegs(e.bgEventSegs||[],e.timelineCoords,"bg-event"),this.renderSegs(n,e.timelineCoords,"highlight"))},n.prototype.renderSegs=function(e,n,i){var o=this.props,r=o.todayRange,s=o.nowDate,l=e.map((function(e){var o=n.rangeToCoords(e);return t.createElement("div",{key:t.buildEventRangeKey(e.eventRange),className:"fc-timeline-bg-harness",style:{left:o.left,right:-o.right}},"bg-event"===i?t.createElement(t.BgEvent,a({seg:e},t.getSegMeta(e,r,s))):t.renderFill(i))}));return t.createElement(t.Fragment,null,l)},n}(t.BaseComponent),P=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return r(n,e),n.prototype.sliceRange=function(e,n,i,o,r){var a=function(e,n,i){if(!n.isTimeScale&&(e=t.computeVisibleDayRange(e),n.largeUnit)){var o=e;((e={start:i.startOf(e.start,n.largeUnit),end:i.startOf(e.end,n.largeUnit)}).end.valueOf()!==o.end.valueOf()||e.end<=e.start)&&(e={start:e.start,end:i.add(e.end,n.slotDuration)})}return e}(e,o,r),s=[];if(R(a.start,o,r)<R(a.end,o,r)){var l=t.intersectRanges(a,o.normalizedRange);l&&s.push({start:l.start,end:l.end,isStart:l.start.valueOf()===a.start.valueOf()&&c(l.start,o,n,i),isEnd:l.end.valueOf()===a.end.valueOf()&&c(t.addMs(l.end,-1),o,n,i)})}return s},n}(t.Slicer),k=t.createFormatter({hour:"numeric",minute:"2-digit",omitZeroMinute:!0,meridiem:"narrow"}),M=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return r(n,e),n.prototype.render=function(){var e=this.props;return t.createElement(t.StandardEvent,a({},e,{extraClassNames:["fc-timeline-event","fc-h-event"],defaultTimeFormat:k,defaultDisplayEventTime:!e.isTimeScale}))},n}(t.BaseComponent);function T(e,t){var n={};if(t)for(var i=0,o=e;i<o.length;i++){var r=o[i];n[r.eventRange.instance.instanceId]=t.rangeToCoords(r)}return n}function W(e,n,i){var o,r,a,s,l=[],u=0;if(i)for(var c=0,d=e=t.sortEventSegs(e,n);c<d.length;c++){var h=d[c].eventRange.instance.instanceId,f=i[h];if(f){for(var m=0,p=0,g=0;g<l.length;g++){var v=l[g];o=f,r=m,a=v.dims,s=v.top,o.right>a.left&&o.left<a.right&&r+o.height>s&&r<s+a.height&&(m=v.top+v.dims.height,p=g)}for(;p<l.length&&m>=l[p].top;)p++;l.splice(p,0,{key:h,dims:f,top:m}),u=Math.max(u,m+f.height)}}for(var y={},D=0,S=l;D<S.length;D++){y[(v=S[D]).key]=v.top}return{segTops:y,height:u}}var I=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.slicer=new P,n.computeFgSegHorizontals=t.memoize(T),n.computeSegVerticals=t.memoize(W),n.harnessElRefs=new t.RefMap,n.innerElRef=t.createRef(),n.state={segDims:null},n}return r(n,e),n.prototype.render=function(){var e=this.props,n=this.state,i=this.context,o=e.dateProfile,r=e.tDateProfile,a=this.slicer.sliceProps(e,o,r.isTimeScale?null:e.nextDayThreshold,i,o,i.dateProfileGenerator,r,i.dateEnv),s=(a.eventDrag?a.eventDrag.segs:null)||(a.eventResize?a.eventResize.segs:null)||[],l=this.computeFgSegHorizontals(a.fgEventSegs,e.timelineCoords),u=this.computeSegVerticals(a.fgEventSegs,i.options.eventOrder,n.segDims),c=u.segTops,d=u.height,h=(a.eventDrag?a.eventDrag.affectedInstances:null)||(a.eventResize?a.eventResize.affectedInstances:null)||{};return t.createElement(t.Fragment,null,t.createElement(b,{businessHourSegs:a.businessHourSegs,bgEventSegs:a.bgEventSegs,timelineCoords:e.timelineCoords,eventResizeSegs:a.eventResize?a.eventResize.segs:[],dateSelectionSegs:a.dateSelectionSegs,nowDate:e.nowDate,todayRange:e.todayRange}),t.createElement("div",{className:"fc-timeline-events fc-scrollgrid-sync-inner",ref:this.innerElRef,style:{height:d}},this.renderFgSegs(a.fgEventSegs,l,c,h,!1,!1,!1),this.renderFgSegs(s,T(s,e.timelineCoords),c,{},Boolean(a.eventDrag),Boolean(a.eventResize),!1)))},n.prototype.componentDidMount=function(){this.updateSize()},n.prototype.componentDidUpdate=function(e,t){e.eventStore===this.props.eventStore&&e.timelineCoords===this.props.timelineCoords||this.updateSize()},n.prototype.updateSize=function(){var e=this,n=this.props,i=n.timelineCoords;if(n.onHeightChange&&n.onHeightChange(this.innerElRef.current,!1),i){var o=i.slatRootEl.getBoundingClientRect();this.setState({segDims:t.mapHash(this.harnessElRefs.currentMap,(function(e){var t=e.getBoundingClientRect();return{left:Math.round(t.left-o.left),right:Math.round(t.right-o.left),height:Math.round(t.height)}}))},(function(){n.onHeightChange&&n.onHeightChange(e.innerElRef.current,!0)}))}},n.prototype.renderFgSegs=function(e,n,i,o,r,s,l){var u=this,c=this.harnessElRefs,d=this.props,h=r||s||l;return t.createElement(t.Fragment,null,e.map((function(e){var f=e.eventRange.instance.instanceId,m=n[f],p=i[f];return t.createElement("div",{key:f,ref:h?null:c.createRef(f),className:"fc-timeline-event-harness",style:{left:m?m.left:"",right:m?-m.right:"",top:null!=p?p:"",visibility:o[f]?"hidden":""}},t.createElement(M,a({isTimeScale:u.props.tDateProfile.isTimeScale,seg:e,isDragging:r,isResizing:s,isDateSelecting:l,isSelected:f===u.props.eventSelection},t.getSegMeta(e,d.todayRange,d.nowDate))))})))},n}(t.BaseComponent),N=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.slatsRef=t.createRef(),n.state={coords:null},n.handeEl=function(e){e?n.context.registerInteractiveComponent(n,{el:e}):n.context.unregisterInteractiveComponent(n)},n.handleCoords=function(e){n.setState({coords:e}),n.props.onSlatCoords&&n.props.onSlatCoords(e)},n}return r(n,e),n.prototype.render=function(){var e=this,n=this.props,i=this.state,o=this.context.options,r=n.dateProfile,a=n.tDateProfile,s=t.greatestDurationDenominator(a.slotDuration).unit;return t.createElement("div",{className:"fc-timeline-body",ref:this.handeEl,style:{minWidth:n.tableMinWidth,height:n.clientHeight,width:n.clientWidth}},t.createElement(t.NowTimer,{unit:s},(function(s,l){return t.createElement(t.Fragment,null,t.createElement(w,{ref:e.slatsRef,dateProfile:r,tDateProfile:a,nowDate:s,todayRange:l,clientWidth:n.clientWidth,tableColGroupNode:n.tableColGroupNode,tableMinWidth:n.tableMinWidth,onCoords:e.handleCoords,onScrollLeftRequest:n.onScrollLeftRequest}),t.createElement(I,{dateProfile:r,tDateProfile:n.tDateProfile,nowDate:s,todayRange:l,nextDayThreshold:o.nextDayThreshold,businessHours:n.businessHours,eventStore:n.eventStore,eventUiBases:n.eventUiBases,dateSelection:n.dateSelection,eventSelection:n.eventSelection,eventDrag:n.eventDrag,eventResize:n.eventResize,timelineCoords:i.coords}),o.nowIndicator&&i.coords&&i.coords.isDateInRange(s)&&t.createElement("div",{className:"fc-timeline-now-indicator-container"},t.createElement(t.NowIndicatorRoot,{isAxis:!1,date:s},(function(e,n,o,r){return t.createElement("div",{ref:e,className:["fc-timeline-now-indicator-line"].concat(n).join(" "),style:{left:i.coords.dateToCoord(s)}},r)}))))})))},n.prototype.queryHit=function(e,t,n,i){var o=this.slatsRef.current.positionToHit(e);if(o)return{component:this,dateSpan:o.dateSpan,rect:{left:o.left,right:o.right,top:0,bottom:i},dayEl:o.dayEl,layer:0}},n}(t.DateComponent),x=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.buildTimelineDateProfile=t.memoize(l),n.scrollGridRef=t.createRef(),n.state={slatCoords:null,slotCushionMaxWidth:null},n.handleSlatCoords=function(e){n.setState({slatCoords:e})},n.handleScrollLeftRequest=function(e){n.scrollGridRef.current.forceScrollLeft(0,e)},n.handleMaxCushionWidth=function(e){n.setState({slotCushionMaxWidth:Math.ceil(e)})},n}return r(n,e),n.prototype.render=function(){var e=this,n=this.props,o=this.state,r=this.context,s=r.options,l=!n.forPrint&&t.getStickyHeaderDates(s),u=!n.forPrint&&t.getStickyFooterScrollbar(s),c=this.buildTimelineDateProfile(n.dateProfile,r.dateEnv,s,r.dateProfileGenerator),d=["fc-timeline",!1===s.eventOverlap?"fc-timeline-overlap-disabled":""],h=s.slotMinWidth,f=L(c,h||this.computeFallbackSlotMinWidth(c)),m=[{type:"header",key:"header",isSticky:l,chunks:[{key:"timeline",content:function(i){return t.createElement(D,{dateProfile:n.dateProfile,clientWidth:i.clientWidth,clientHeight:i.clientHeight,tableMinWidth:i.tableMinWidth,tableColGroupNode:i.tableColGroupNode,tDateProfile:c,slatCoords:o.slatCoords,onMaxCushionWidth:h?null:e.handleMaxCushionWidth})}}]},{type:"body",key:"body",liquid:!0,chunks:[{key:"timeline",content:function(i){return t.createElement(N,a({},n,{clientWidth:i.clientWidth,clientHeight:i.clientHeight,tableMinWidth:i.tableMinWidth,tableColGroupNode:i.tableColGroupNode,tDateProfile:c,onSlatCoords:e.handleSlatCoords,onScrollLeftRequest:e.handleScrollLeftRequest}))}}]}];return u&&m.push({type:"footer",key:"footer",isSticky:!0,chunks:[{key:"timeline",content:t.renderScrollShim}]}),t.createElement(t.ViewRoot,{viewSpec:r.viewSpec},(function(o,r){return t.createElement("div",{ref:o,className:d.concat(r).join(" ")},t.createElement(i.ScrollGrid,{ref:e.scrollGridRef,liquid:!n.isHeightAuto&&!n.forPrint,colGroups:[{cols:f}],sections:m}))}))},n.prototype.computeFallbackSlotMinWidth=function(e){return Math.max(30,(this.state.slotCushionMaxWidth||0)/e.slotsPerLabel)},n}(t.DateComponent);function L(e,t){return[{span:e.slotCnt,minWidth:t||1}]}var z=t.createPlugin({deps:[n],initialView:"timelineDay",views:{timeline:{component:x,usesMinMaxTime:!0,eventResizableFromStart:!0},timelineDay:{type:"timeline",duration:{days:1}},timelineWeek:{type:"timeline",duration:{weeks:1}},timelineMonth:{type:"timeline",duration:{months:1}},timelineYear:{type:"timeline",duration:{years:1}}}});return t.globalPlugins.push(z),e.TimelineCoords=C,e.TimelineHeader=D,e.TimelineHeaderRows=y,e.TimelineLane=I,e.TimelineLaneBg=b,e.TimelineLaneSlicer=P,e.TimelineSlats=w,e.TimelineView=x,e.buildSlatCols=L,e.buildTimelineDateProfile=l,e.default=z,e}({},FullCalendar,FullCalendarPremiumCommon,FullCalendarScrollGrid);